=== build/docker/Makefile ===

ROOT=../..
MK.pyver:=3
include $(ROOT)/deps/readies/mk/main

REDIS_VERSION=6.2.6
REPO=redistimeseries

OSNICK.official=bullseye

INT_BRANCHES=1.6 1.4
LATEST_BRANCH=1.6
PREVIEW_BRANCH=1.6

ART_DIR=$(ROOT)/bin/artifacts

include $(MK)/module.docker.rules
