=== deps/readies/paella/requirements.txt ===
addict
click
jinja2
requests
semantic_version
six
toml
virtualenv
