=== debian/changelog ===
redis-timeseries-src (1.6.16.2-1) stable; urgency=medium

  * current version

 -- uib GmbH <info@uib.de>  Wed, 06 Jul 2022 08:38:45 +0000
