=== debian/control ===
Source: redis-timeseries-src
Section: opsi
Priority: optional
Maintainer: uib GmbH <info@uib.de>
Homepage: https://github.com/RedisTimeSeries/RedisTimeSeries
Build-Depends: debhelper (>= 9.2~), gcc, g++ | gcc-c++, make, python3 | python37 | python3.7| python36 | python3.6 | python, python3-dev | python3-devel, python3-pip, m4, automake, openssl, libssl-dev | openssl-devel, libtool, valgrind
Standards-Version: 3.9.4

Package: redis-timeseries
Section: opsi
Architecture: any
Depends: redis-server
Suggests: 
Provides: 
Breaks: 
Replaces: 
Conflicts: 
Description: RedisTimeSeries is a Redis Module adding a Time Series data structure to Redis.
 RedisTimeSeries is a Redis Module adding a Time Series data structure to Redis.
